c      real*8  e, xs
c      e = 0.1
c      do while (.true.)
c         call cpbarpXsec(e, xs)
c         write(*,*) sqrt( e * (e+2*0.938)), xs
c         e = e * 10.**0.1
c         if(e .gt. 5000.) goto 10
c      enddo
c 10   continue
c      end
c
c   inelastic cross-section at enetire  energy.
c   IncreaseXsec =2 should not be used.
c        cppXsec   p   p      n p
c        cpbarpXsec  p_b p      n_b  n    n_b p   p_b n
c        cpiMinuspXsec  pi- p
c        cpiPluspXsec  pi+ p
c        ckMinuspXsec  k-  p      k0_b n
c        ckPluspXsec k+  p k+ n  k- n   k0_b  p   k0 n
c        real*8 e, xs
c        e=1000.
c        call cppXsec(e, xs)
c        write(*,*) xs
c        end
c       ***********************************************************
c       *
c       * p_p inelastic cross-section
c       *
c       ****************** tested 88.08.11 *****************k.k ***
c
c    e:real*8.  input. kinetic energy of partilce in GeV.
c   xs:real*8   output. Inelastic cross-section in mb
c
        subroutine cppXsec(e, xs)
        implicit none
#include  "Zmass.h"
        real*8 e, xs
        real*8 p
c        p = sqrt( (e+masp)**2 - masp**2 )
        p = sqrt( e*(e+masp+masp) )
        call cppInelaXs(p, xs)
      end
c       ***********************************************************
c       *
c       * p_b p inelastic cross-section
c       *
c       ******************                 *****************k.k ***
c
c   e: input.  e kinetic energy in GeV
c   xs:output. inelastic cross-section in mb
c
        subroutine cpbarpXsec(e, xs)
        implicit none
#include "Zmass.h"
        real*8 e, xs
        real*8 p
        p = sqrt( e*(e+masp+masp) )
        call cpbarpInelaXs(p, xs)
        end
c       ***********************************************************
c       *
c       * pi- p inelastic cross-section
c       *
c       ****************** tested 88.08.11 *****************k.k ***
c
c   e: input.  pi- k.e     in GeV
c   xs:output. inelastic cross-section in mb
c
        subroutine cpiMinuspXsec(e, xs)
        implicit none
#include "Zmass.h"
        real*8 e, xs
        real*8 p
        p = sqrt( e * ( e + maspic + maspic) ) 
        call cpimpInelaXs(p, xs)
      end
c       ***********************************************************
c       *
c       * pi+ p inelastic cross-section
c       *
c       ****************** tested 88.08.11 *****************k.k ***
c
c   e: input.  pi+ k.e     in GeV
c   xs:output. inelastic cross-section in mb
c
        subroutine cpiPluspXsec(e, xs)
        implicit none
#include  "Zmass.h"
        real*8 e, xs
        real*8 p
        p = sqrt( e * ( e + maspic + maspic) ) 
        call cpippInelaXs(p, xs)
      end
c       ***********************************************************
c       *
c       * k-  p inelastic cross-section
c       *
c       ****************** tested 88.08.11 *****************k.k ***
c
c   e: input.  k- k.e   GeV
c   xs:output. inelastic cross-section in mb
c
        subroutine ckMinuspXsec(e, xs)
        implicit none
#include  "Zmass.h"
        real*8 e, xs
        real*8 p
        p=sqrt( e*(e+maskc+maskc) )
        call ckmpInelaXs(p, xs)
      end
c       ***********************************************************
c       *
c       * k+  p inelastic cross-section
c       *
c       ****************** tested 88.08.11 *****************k.k ***
c
c   e: input.  k+ k.e    GeV
c   xs:output. inelastic cross-section in mb
c
        subroutine ckPluspXsec(e, xs)
        implicit none
c----        include 'Zxsectionp.h'
#include  "Zmass.h"
        real*8 e, xs
        real*8 p
        p=sqrt( e*(e+maskc+maskc) )
        call ckppInelaXs(p, xs)
      end
